/* logint.c */
#include <stdio.h>

/* Dato un intero x>0, il logaritmo intero di x e' il massimo intero n
   tale che 2^n <= x (qui ^ indica l'elevamento a potenza).  Ad
   esempio, il logaritmo intero di 1 vale 0; il logaritmo intero di 2
   vale 1; il logaritmo intero di 9 vale 3.

   Completare la funzioen logint(x) seguente in modo che restituisca
   il logaritmo intero di x.

   ATTENZIONE: non e' consentito usare alcuna funzione presente in
   math.h (quindi non si puo' usare ne' la funzione log2() ne' la
   funzione pow() per l'elevamento a potenza).
*/
int logint(int x)
{
    return -1;
}

/**
 ** Non dovrebbe essere necessario modificare le funzioni seguenti.
 **/
void test(int x, int expect)
{
    int r = logint(x);
    if ( r == expect ) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: x=%d, risultato atteso=%d, risultato ottenuto=%d\n", x, expect, r);
    }
}

int main( void )
{
    test(1, 0);
    test(2, 1);
    test(3, 1);
    test(4, 2);
    test(9, 3);
    test(16, 4);
    test(17, 4);
    test(128, 7);
    test(1023, 9);
    test(1024, 10);
    test(1025, 10);

    return 0;
}
